/***************************************************************************
 *                                                                         *
 *   FAZGOB.C     (GOBJCT.C)                                               *
 *                                                                         *
 *   Copyright (C) 1984, 1986, 1991 GALACTICOMM, Inc. All Rights Reserved. *
 *                                                                         *
 ***************************************************************************/

#include "gcomm.h"
#include "fazdat.h"
#include "galfaz.h"

STATIC void nocmds(void);

STATIC void
nocmds(void)
{
     return;
}

struct object objcts[TOTOBJ]={
/* 000 */ {"gwingus"," hovering a few feet away",
          OBJTKB+ACTBUT,"",
          FAZ1000,gwing,nocmds,
          {&objcts[14],&objcts[13],&objcts[11],&objcts[7]},0,0},
/* 001 */ {"torkus"," lying %s",
          OBJTKB,"",
          FAZ1001,nocmds,nocmds,
          {&objcts[14],&objcts[12],&objcts[10],&objcts[8]},0,0},
/* 002 */ {"mongoo"," lying %s",
          OBJTKB,"",
          FAZ1002,nocmds,nocmds,
          {&objcts[13],&objcts[10],&objcts[9],&objcts[6]},0,0},
/* 003 */ {"snuge"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1003,snuge,nocmds,
          {&objcts[12],&objcts[11],&objcts[9],&objcts[5]},0,0},
/* 004 */ {"wigglesnort"," lying %s",
          OBJTKB,"",
          FAZ1004,nocmds,nocmds,
          {&objcts[8],&objcts[7],&objcts[6],&objcts[5]},0,0},
/* 005 */ {"dampish"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1005,klonk,nocmds,
          {&objcts[23],&objcts[24],0,0},&objcts[3],&objcts[4]},
/* 006 */ {"frakkle"," lying %s",
          OBJTKB+OBJRDA,"",
          FAZ1006,nocmds,nocmds,
          {&objcts[22],&objcts[23],0,0},&objcts[4],&objcts[2]},
/* 007 */ {"bilge"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1007,bilge,nocmds,
          {&objcts[21],&objcts[22],&objcts[24],0},&objcts[0],&objcts[4]},
/* 008 */ {"bork"," lying %s",
          OBJTKB+ACTTNK,"",
          FAZ1008,bork,nocmds,
          {&objcts[20],&objcts[21],0,0},&objcts[1],&objcts[4]},
/* 009 */ {"rukkle"," lying %s",
          OBJTKB+OBJRDA,"",
          FAZ1009,nocmds,nocmds,
          {&objcts[19],&objcts[20],0,0},&objcts[2],&objcts[3]},
/* 010 */ {"framus"," lying %s",
          OBJTKB,"",
          FAZ1010,nocmds,nocmds,
          {&objcts[18],&objcts[19],0,0},&objcts[1],&objcts[2]},
/* 011 */ {"rhubarb"," lying %s",
          OBJTKB+ACTTNK,"",
          FAZ1011,rhuba,nocmds,
          {&objcts[17],&objcts[18],0,0},&objcts[0],&objcts[3]},
/* 012 */ {"gongo"," lying %s",
          OBJTKB,"",
          FAZ1012,nocmds,nocmds,
          {&objcts[16],&objcts[17],0,0},&objcts[1],&objcts[3]},
/* 013 */ {"moolkoo"," floating in the air",
          OBJTKB+ACTKCK,"",
          FAZ1013,moolk,nocmds,
          {&objcts[15],&objcts[16],0,0},&objcts[0],&objcts[2]},
/* 014 */ {"wufflar"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1014,wufflar,nocmds,
          {&objcts[15],0,0,0},&objcts[0],&objcts[1]},
/* 015 */ {"nylarx"," lying %s",
          OBJTKB,"",
          FAZ1015,nocmds,nocmds,
          {&objcts[33],0,0,0},&objcts[14],&objcts[13]},
/* 016 */ {"tracton"," lying %s",
          OBJTKB,"",
          FAZ1016,nocmds,nocmds,
          {&objcts[34],&objcts[32],0,0},&objcts[13],&objcts[12]},
/* 017 */ {"suvar"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1017,suvar,nocmds,
          {&objcts[33],&objcts[31],0,0},&objcts[12],&objcts[11]},
/* 018 */ {"ravus"," whirling around your feet",
          OBJTKB,"",
          FAZ1018,nocmds,nocmds,
          {&objcts[32],&objcts[30],0,0},&objcts[11],&objcts[10]},
/* 019 */ {"sepper"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1019,seppe,nocmds,
          {&objcts[34],&objcts[31],&objcts[29],0},&objcts[10],&objcts[9]},
/* 020 */ {"palt"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1020,palt,nocmds,
          {&objcts[30],&objcts[28],0,0},&objcts[9],&objcts[8]},
/* 021 */ {"traset"," lying %s",
          OBJTKB,"",
          FAZ1021,nocmds,nocmds,
          {&objcts[29],&objcts[27],0,0},&objcts[8],&objcts[7]},
/* 022 */ {"cistle"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1022,cistl,nocmds,
          {&objcts[28],&objcts[26],&objcts[25],0},&objcts[7],&objcts[6]},
/* 023 */ {"torrel"," lying %s",
          OBJTKB,"",
          FAZ1023,nocmds,nocmds,
          {&objcts[27],&objcts[25],0,0},&objcts[6],&objcts[5]},
/* 024 */ {"rommus"," making strange noises %s",
          OBJTKB+ACTBUT,"",
          FAZ1024,rommu,nocmds,
          {&objcts[26],0,0,0},&objcts[7],&objcts[5]},
/* 025 */ {"ruckus"," lying %s",
          OBJTKB+ACTKCK,"",
          FAZ1025,rucku,nocmds,
          {&objcts[42],&objcts[43],0,0},&objcts[22],&objcts[23]},
/* 026 */ {"bundle"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1026,bundl,nocmds,
          {&objcts[41],0,0,0},&objcts[22],&objcts[24]},
/* 027 */ {"nabob"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1027,nabob,nocmds,
          {&objcts[40],&objcts[43],0,0},&objcts[21],&objcts[23]},
/* 028 */ {"bagloon"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1028,bagl3,nocmds,
          {&objcts[39],&objcts[42],0,0},&objcts[20],&objcts[22]},
/* 029 */ {"snarp"," lying %s",
          OBJTKB+OBJRDA,"",
          FAZ1029,nocmds,nocmds,
          {&objcts[38],&objcts[41],0,0},&objcts[19],&objcts[21]},
/* 030 */ {"dweezle"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1030,dweez,nocmds,
          {&objcts[37],&objcts[40],0,0},&objcts[18],&objcts[20]},
/* 031 */ {"flingle"," whirling around your feet",
          OBJTKB,"",
          FAZ1031,nocmds,nocmds,
          {&objcts[36],&objcts[39],0,0},&objcts[17],&objcts[19]},
/* 032 */ {"zarkon"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1032,zarpnt,nocmds,
          {&objcts[35],&objcts[38],0,0},&objcts[16],&objcts[18]},
/* 033 */ {"cacapoo"," lying %s",
          OBJTKB+ACTKCK,"",
          FAZ1033,cacap,nocmds,
          {&objcts[35],&objcts[37],0,0},&objcts[15],&objcts[17]},
/* 034 */ {"kootpod"," lying %s",
          OBJTKB+ACTKCK,"",
          FAZ1034,koot4,nocmds,
          {&objcts[36],0,0,0},&objcts[16],&objcts[19]},
/* 035 */ {"dongle"," lying %s",
          OBJTKB,"",
          FAZ1035,nocmds,nocmds,
          {&objcts[51],0,0,0},&objcts[33],&objcts[32]},
/* 036 */ {"bagloon"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1036,bagl4,nocmds,
          {&objcts[51],&objcts[50],0,0},&objcts[34],&objcts[31]},
/* 037 */ {"felafel"," lying %s",
          OBJTKB,"",
          FAZ1037,nocmds,nocmds,
          {&objcts[50],&objcts[49],0,0},&objcts[33],&objcts[30]},
/* 038 */ {"zarkon"," lying %s",
          OBJTKB,"",
          FAZ1038,nocmds,nocmds,
          {&objcts[49],&objcts[48],0,0},&objcts[32],&objcts[29]},
/* 039 */ {"kwish"," airing itself out %s",
          OBJTKB+ACTBUT,"",
          FAZ1039,kwish,nocmds,
          {&objcts[48],&objcts[47],0,0},&objcts[31],&objcts[28]},
/* 040 */ {"snalt"," lying %s",
          OBJTKB,"",
          FAZ1040,nocmds,nocmds,
          {&objcts[47],&objcts[46],0,0},&objcts[30],&objcts[27]},
/* 041 */ {"quorum"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1041,quoru,nocmds,
          {&objcts[46],&objcts[45],0,0},&objcts[29],&objcts[26]},
/* 042 */ {"fracas"," lying %s",
          OBJTKB,"",
          FAZ1042,nocmds,nocmds,
          {&objcts[45],&objcts[44],0,0},&objcts[28],&objcts[25]},
/* 043 */ {"dweezle"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1043,dweez,nocmds,
          {&objcts[44],0,0,0},&objcts[27],&objcts[25]},
/* 044 */ {"kootpod"," lying %s",
          OBJTKB+ACTKCK,"",
          FAZ1044,koot5,nocmds,
          {&objcts[60],&objcts[62],0,0},&objcts[42],&objcts[43]},
/* 045 */ {"wapple"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1045,wappl,nocmds,
          {&objcts[58],&objcts[62],0,0},&objcts[41],&objcts[42]},
/* 046 */ {"bagloon"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1046,bagl5,nocmds,
          {&objcts[56],&objcts[60],0,0},&objcts[40],&objcts[41]},
/* 047 */ {"nebbish"," taking five",
          OBJTKB+ACTPNT,"",
          FAZ1047,nebbi,nocmds,
          {&objcts[54],&objcts[58],0,0},&objcts[39],&objcts[40]},
/* 048 */ {"quahog"," lying %s",
          OBJTKB,"",
          FAZ1048,nocmds,nocmds,
          {&objcts[53],&objcts[56],0,0},&objcts[38],&objcts[39]},
/* 049 */ {"wongum"," lying %s",
          OBJTKB+ACTTNK,"",
          FAZ1049,wongu,wongo,
          {&objcts[52],&objcts[54],0,0},&objcts[37],&objcts[38]},
/* 050 */ {"narret"," lying %s",
          OBJTKB+ACTTNK,"",
          FAZ1050,narre,nocmds,
          {&objcts[53],0,0,0},&objcts[36],&objcts[37]},
/* 051 */ {"quahog"," lying %s",
          OBJTKB,"",
          FAZ1051,nocmds,nocmds,
          {&objcts[52],0,0,0},&objcts[35],&objcts[36]},
/* 052 */ {"greeb"," whirling around your feet",
          OBJTKB,"",
          FAZ1052,nocmds,nocmds,
          {&objcts[68],&objcts[67],0,0},&objcts[51],&objcts[49]},
/* 053 */ {"drivel"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1053,drive,nocmds,
          {&objcts[66],0,0,0},&objcts[50],&objcts[48]},
/* 054 */ {"quahog"," lying %s",
          OBJTKB,"",
          FAZ1054,nocmds,nocmds,
          {&objcts[68],&objcts[65],0,0},&objcts[49],&objcts[47]},
/* 055 */ {"foonprize"," lying %s",
          OBJTKB,"",
          FAZ1055,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 056 */ {"narn"," hanging suspended in space",
          OBJTKB+ACTTNK,"",
          FAZ1056,pasta,nocmds,
          {&objcts[67],&objcts[64],0,0},&objcts[48],&objcts[46]},
/* 057 */ {"zleen"," wiggling around %s",
          OBJTKB,"",
          FAZ1057,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 058 */ {"noodle"," lying %s",
          OBJTKB+ACTTNK,"",
          FAZ1058,noodl,nocmds,
          {&objcts[66],&objcts[63],0,0},&objcts[47],&objcts[45]},
/* 059 */ {"flungoon"," lying %s",
          OBJTKB,"",
          FAZ1059,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 060 */ {"scroom"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1060,scroo,nocmds,
          {&objcts[65],0,0,0},&objcts[46],&objcts[44]},
/* 061 */ {"rebozo"," lying %s",
          OBJTKB,"",
          FAZ1061,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 062 */ {"fashnork"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1062,fashn,fasho,
          {&objcts[64],&objcts[63],0,0},&objcts[45],&objcts[44]},
/* 063 */ {"ceeveese"," lying %s",
          OBJTKB+OBJRDA,"",
          FAZ1063,nocmds,nocmds,
          {0,0,0,0},&objcts[58],&objcts[62]},
/* 064 */ {"quice"," lying %s",
          OBJTKB+ACTTNK,"",
          FAZ1064,quice,nocmds,
          {0,0,0,0},&objcts[56],&objcts[62]},
/* 065 */ {"kootpod"," lying %s",
          OBJTKB+ACTKCK,"",
          FAZ1065,koot6,nocmds,
          {0,0,0,0},&objcts[54],&objcts[60]},
/* 066 */ {"snaack"," lying %s",
          OBJTKB+ACTBUT,"",
          FAZ1066,snaac,nocmds,
          {0,0,0,0},&objcts[53],&objcts[58]},
/* 067 */ {"babbalisk"," lying %s",
          OBJTKB+ACTPNT,"",
          FAZ1067,babba,nocmds,
          {0,0,0,0},&objcts[52],&objcts[56]},
/* 068 */ {"quilbert"," laying around unprotected",
          OBJTKB+ACTPNT,"",
          FAZ1068,quilbert,nocmds,
          {0,0,0,0},&objcts[52],&objcts[54]},
/* 069 */ {"desk","sitting there",
          OBJNVS,"It's much too heavy!",
          FAZ1069,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 070 */ {"dirt","sitting there",
          OBJNVS,"The dirt seems to just slip through your fingers.",
          FAZ1070,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 071 */ {"slot","sitting there",       /* hexagonal */
          OBJNVS,"Come now, trying to take a slot?!?",
          FAZ1071,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 072 */ {"slot","sitting there",       /* fist, in xporter */
          OBJNVS,"Sure, sure, thought you'd find a bug in the program, eh?",
          FAZ1072,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 073 */ {"map","sitting there",
          OBJNVS+OBJRDA,"You can't, the map is painted onto the wall.",
          FAZ1073,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 074 */ {"osmotic","sitting there",
          OBJNVS,"The osmotic doesn't even budge.",
          FAZ1074,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 075 */ {"case","sitting there",
          OBJNVS,"It doesn't seem to want to come loose.",
          FAZ1075,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 076 */ {"substances","sitting there",
          OBJNVS,"You can't, they are inside the cases.",
          FAZ1076,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 077 */ {"globe","sitting there",
          OBJNVS,"Be reasonable!  It's huge!",
          FAZ1077,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 078 */ {"sphere","sitting there",
          OBJNVS,"What, are you trying to get a hernia?",
          FAZ1078,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 079 */ {"gate","sitting there",       /* courtyard */
          OBJNVS,"OOO-OOF!  Sorry, it seems to be bolted in place.",
          FAZ1079,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 080 */ {"gate","sitting there",       /* outside */
          OBJNVS,"Sure, sure, thought you'd find a bug in the program, eh?",
          FAZ1080,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 081 */ {"instructions","sitting there",
          OBJNVS+OBJRDA,"They are painted onto the wall, silly!",
          FAZ1081,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 082 */ {"lights","sitting there",
          OBJNVS,"The lights appear to be built into the dome ceiling.",
          FAZ1082,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 083 */ {"machine","sitting there",
          OBJNVS,"The machine jumps up in the air and lands on your foot!  Ouch!",
          FAZ1083,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 084 */ {"spare","not used",
          OBJNVS,"not used",
          0,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 085 */ {"spare","not used",
          OBJNVS,"not used",
          0,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 086 */ {"spare","not used",
          OBJNVS,"not used",
          0,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 087 */ {"spare","not used",
          OBJNVS,"not used",
          0,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 088 */ {"wheel","sitting there",
          OBJNVS+OBJRDA,"It doesn't seem to want to come loose.",
          FAZ1088,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 089 */ {"grinfrazzitz","sitting there",
          OBJNVS,"It's much too big!",
          FAZ1089,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 090 */ {"tables","sitting there",
          OBJNVS,"The tables seem to be anchored to the floor.",
          FAZ1090,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 091 */ {"sparks","sitting there",
          OBJNVS,"Come now, they're sparks!",
          FAZ1091,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 092 */ {"carpeting","sitting there",
          OBJNVS,"It seems to be fairly well attached to the floor.",
          FAZ1092,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 093 */ {"stars","sitting there",
          OBJNVS,"You would need awfully long arms for that!",
          FAZ1093,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 094 */ {"sign","sitting there",
          OBJNVS+OBJRDA,"The sign pulls out a .45 as you reach for it!",
          FAZ1094,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 095 */ {"machinery","sitting there",
          OBJNVS,"Come now, there's a whole roomful here!",
          FAZ1095,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 096 */ {"panel","sitting there",
          OBJNVS+OBJRDA,"The spirit of the panel says no, you can't have it.",
          FAZ1096,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 097 */ {"hopper","sitting there",
          OBJNVS,"It doesn't seem to want to come loose.",
          FAZ1097,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 098 */ {"console","sitting there",
          OBJNVS+OBJRDA,"A little hammer pops out of the console and raps your knuckles!",
          FAZ1098,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 099 */ {"buttons","sitting there",
          OBJNVS,"The buttons scream \"Mommy Mommy!\"",
          FAZ1099,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 100 */ {"globes","sitting there",
          OBJNVS,"The globes seem to evade you as you reach for them.",
          FAZ1100,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 101 */ {"desk","sitting there",
          OBJNVS,"It's attached to the floor.",
          FAZ1101,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 102 */ {"pattern","sitting there",
          OBJNVS,"Your hands pass right through it, as if it were just light.",
          FAZ1102,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 103 */ {"light","sitting there",
          OBJNVS,"Your hands pass right through it, as if it were just light.",
          FAZ1103,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 104 */ {"granfalloon","sitting there",
          OBJNVS,"You can't be serious, it's huge!",
          FAZ1104,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 105 */ {"benches","sitting there",
          OBJNVS,"The benches seem to be attached to the floor.",
          FAZ1105,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 106 */ {"ribbenfratz","sitting there",
          OBJNVS,"You don't seem to have enough strength.",
          FAZ1106,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 107 */ {"globules","sitting there",
          OBJNVS,"The globules seem to shy away from your hands.",
          FAZ1107,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 108 */ {"light","sitting there",
          OBJNVS,"Now, how do you propose to carry light?",
          FAZ1108,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 109 */ {"coils","sitting there",
          OBJNVS,"You and what other fifty people?",
          FAZ1109,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 110 */ {"hopper","sitting there",
          OBJNVS,"It doesn't seem to want to come loose.",
          FAZ1110,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 111 */ {"desks","sitting there",
          OBJNVS,"The desks appear to be attached to the floor.",
          FAZ1111,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 112 */ {"console","sitting there",
          OBJNVS+OBJRDA,
          "The elf inside the console runs out and kicks you in the shins!",
          FAZ1112,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 113 */ {"ceiling","sitting there",
          OBJNVS,"Don't be ridiculous!",
          FAZ1113,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 114 */ {"box","sitting there",
          OBJNVS,"The box appears to be firmly attached to the wall.",
          FAZ1114,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 115 */ {"ball","sitting there",
          OBJNVS,"A force field over the wheel seems to keep your hand out.",
          FAZ1115,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 116 */ {"gwirg"," whirring breathlessly at your feet",
          ACTPNT,"The gwirg suddenly skitters away from you!",
          FAZ1116,quilb,nocmds,
          {0,0,0,0},0,0},
/* 117 */ {"oolgorboid"," just sitting around",
          OBJNVS,"You suddenly feel as though picking up the oolgorboid might not be such a good idea.",
          FAZ1117,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 118 */ {"spare","sitting there",
          OBJNVS,"",
          0,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 119 */ {"wall","sitting there",
          OBJNVS+OBJRDA,"No.",
          FAZ1120,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 120 */ {"hieroglyphics","sitting there",
          OBJNVS+OBJRDA,"Come now, they're engraved into the wall!",
          FAZ1120,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 121 */ {"plaque","sitting there",
          OBJNVS+OBJRDA,"You can't, the plaque is built into the wall.",
          FAZ1121,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 122 */ {"spaceship","sitting there",
          OBJNVS+OBJRDA,"You would have to eat some Wheaties for that!",
          FAZ1122,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 123 */ {"hole","sitting there",
          OBJNVS,"You can't take a hole!",
          FAZ1123,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 124 */ {"panel","sitting there",
          OBJNVS+OBJRDA,"It appears to be firmly attached.",
          FAZ1124,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 125 */ {"cylinder","sitting there",
          OBJNVS,"The cylinder seems to be deeply embedded in the dirt.",
          FAZ1125,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 126 */ {"hemisphere","sitting there",
          OBJNVS,"You don't seem to be able to get a good grip.",
          FAZ1126,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 127 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It won't budge.",
          FAZ1127,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 128 */ {"gwamp"," glittering %s",
          OBJTKB,"",
          FAZ1128,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 129 */ {"slosh"," glittering %s",
          OBJTKB,"",
          FAZ1129,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 130 */ {"tuskaloosa"," glittering %s",
          OBJTKB,"",
          FAZ1130,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 131 */ {"freenish","sitting there",
          OBJNVS,"It seems to be firmly embedded in the ground.",
          FAZ1131,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 132 */ {"freenish","sitting there",
          OBJNVS,"It seems to be firmly embedded in the ground.",
          FAZ1132,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 133 */ {"mongooosk","sitting there",
          OBJNVS,"You and what other fifty people?",
          FAZ1133,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 134 */ {"sweenars","sitting there",
          OBJNVS,"Oh, the mongooosk doesn't like that!",
          FAZ1134,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 135 */ {"rock","sitting there",
          OBJNVS,"It seems to be firmly embedded in the ground.",
          FAZ1135,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 136 */ {"spaceship","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1136,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 137 */ {"hull","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1136,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 138 */ {"oddlewokkus","sitting there",
          OBJNVS,"You can't, it's the oddlewokkus!",
          FAZ1138,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 139 */ {"blub","sitting there",
          OBJNVS,"You can't, it's not made of matter!",
          FAZ1139,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 140 */ {"nofzinger","sitting there",
          OBJNVS,"You don't have anything to capture it in!",
          FAZ1140,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 141 */ {"statue","sitting there",
          OBJNVS,"It seems to be firmly embedded in the ground.",
          FAZ1141,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 142 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1142,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 143 */ {"orb","sitting there",
          OBJNVS,"The orb shoots out a giant blue spark as you reach for it!",
          FAZ1143,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 144 */ {"pedestal","sitting there",
          OBJNVS,"It seems to be firmly embedded in the ground.",
          FAZ1144,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 145 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1145,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 146 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1146,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 147 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1147,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 148 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1148,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 149 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1149,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 150 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1150,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 151 */ {"monolith","sitting there",
          OBJNVS+OBJRDA,"It seems to be firmly embedded in the ground.",
          FAZ1151,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 152 */ {"platform","sitting there",
          OBJNVS,"It seems to be firmly embedded in the ground.",
          FAZ1152,nocmds,nocmds,
          {0,0,0,0},0,0},
/* 153 */ {"fluid","sitting there",
          OBJNVS,"It seems to evaporate the instant your fingers touch it!",
          FAZ1153,nocmds,nocmds,
          {0,0,0,0},0,0}
};
